unit timer_FStart;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ComCtrls, Grids, ValEdit, XPMan;

type
	TFStart = class(TForm)
    Pages: TPageControl;
		ts1: TTabSheet;
		ts2: TTabSheet;
		Em: TEdit;
		Label1: TLabel;
		Es: TEdit;
		btnStart: TButton;
    p2EName: TEdit;
    p2EM: TEdit;
    p2ES: TEdit;
    p2LColon: TLabel;
		btnSave: TButton;
    btnAddMode: TButton;
    TheList: TValueListEditor;
    btnRemove: TButton;
    p2btnStart: TButton;
    btnEdit: TButton;
    

		procedure btnStartClick(Sender: TObject);


		procedure FormShow(Sender: TObject);
      procedure FormHide(Sender: TObject);


      procedure EmKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);
		procedure EsKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);

         
		procedure btnAddModeClick(Sender: TObject);

		procedure btnSaveClick(Sender: TObject);
		procedure TheListDblClick(Sender: TObject);
		procedure TheListKeyDown(Sender: TObject; var Key: Word;
			Shift: TShiftState);

		procedure PagesChange(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure p2btnStartClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure TheListClick(Sender: TObject);



	private
		{ Private declarations }
	public

		function MoveValue(Value:Integer;  PlusOrMinus:String;  MinutesOrSeconds:String) : integer;


	end;

var
	FStart: TFStart;

implementation

uses timer_F;

{$R *.DFM}


// ------------------------------------------
// page1.btnStart.Click...

procedure TFStart.btnStartClick(Sender: TObject);
var c : integer;
begin
	if Em.text = '' then Em.text := '0';
	if Es.text = '' then Es.text := '0';

	c := strToInt(Em.text) * 60 + strToInt(Es.text);
	if c > 0 then
   begin
   	F.StartTimer(c);
      LastManualTime := c;
		FStart.Close;
   end;
end;



// ------------------------------------------
// page1.EM.Keydown

procedure TFStart.EmKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
var Value: Integer;
begin
	Value := strToInt(Em.Text);
	// @todo - rewrite as better and separated procedure (also onScrollDown/Up)
	if (Key = VK_ESCAPE) then FStart.Hide
	else if (Key = VK_DOWN) then Em.Text := intToStr(MoveValue(Value, 'Minus', 'Minutes'))
	else if (Key = VK_UP) then Em.Text := intToStr(MoveValue(Value, 'Plus', 'Minutes'));
end;



// ------------------------------------------
// page1.ES.Keydown


procedure TFStart.EsKeyDown(Sender: TObject; var Key: Word;
	Shift: TShiftState);
var Value: Integer;
begin
	Value := strToInt(Es.Text);

	// @todo - rewrite as better and separated procedure (also onScrollDown/Up)
	if (Key = VK_ESCAPE) then FStart.Hide
	else if (Key = VK_DOWN) then Es.Text := intToStr(MoveValue(Value, 'Minus', 'Seconds'))
	else if (Key = VK_UP) then Es.Text := intToStr(MoveValue(Value, 'Plus', 'Seconds'));
end;



// ------------------------------------------
// form.Hide

procedure TFStart.FormHide(Sender: TObject);
begin

	// page 1 -- nothing. This' content is saved when new countdown starts.

   // page 2 - save the list
   try TheList.Strings.SaveToFile('tt_times.txt');
	except end;

end;



// ------------------------------------------
// form.Show

procedure TFStart.FormShow(Sender: TObject);
begin

	// form size
   Pages.ActivePageIndex := 0;
	PagesChange(self);

	// load content of page 1
	try
		Em.text := intToStr(LastManualTime div 60);
		Es.text := intToStr(LastManualTime mod 60);
	except
	end;

   // load content of page 2
   try TheList.Strings.LoadFromFile('tt_times.txt');
	except end;

	// focus page1 + EM
	Pages.ActivePageIndex := 0;
   Em.SetFocus;
   Em.SelectAll;

end;




// ------------------------------------------
//

procedure TFStart.btnAddModeClick(Sender: TObject);
begin

   p2EName.Visible := True;
   p2EM.Visible := True;
   p2ES.Visible := True;
   p2LColon.Visible := True;
   btnSave.Visible := True;

	p2Ename.Text := '';
	p2Em.Text := '';
	p2Es.Text := '';

   btnSave.Caption := 'Add';
   p2Ename.SetFocus;
   
end;



// ------------------------------------------
// btnSave.Click -> Update or Add

procedure TFStart.btnSaveClick(Sender: TObject);
begin

   if (btnSave.Caption = 'Add') then begin // caption checking sucks but works

   	// add row
      // ************************

      if (p2EM.Text = '') then p2EM.Text := '0';
      if (p2ES.Text = '') then p2ES.Text := '0';
      // @todo would be good check if it's integer
      TheList.InsertRow(p2EName.Text, p2EM.Text + ':' + p2ES.Text, True);
      
      p2EName.SetFocus;
      

   end else begin

   	// save changes
      // ************************

      TheList.Cells[0, TheList.Selection.Top] := p2EName.Text;
      TheList.Cells[1, TheList.Selection.Top] := p2EM.Text + ':' + p2ES.Text;
      // note: file is saved onFormHide


      // hide fields, show AddMode button

		p2EName.Visible := False;
		p2EM.Visible := False;
		p2ES.Visible := False;
		p2LColon.Visible := False;
		btnSave.Visible := False;

      TheList.SetFocus;

   end;

   // finally empty the fields
   // ************************

	p2Ename.Text := '';
	p2Em.Text := '';
	p2Es.Text := '';

end;



// ------------------------------------------
// TheList.DoubleClick -> Start countdown

procedure TFStart.TheListDblClick(Sender: TObject);
	var t, m, s :string;
	c : integer;
begin
	t := TheList.Cells[1, TheList.Selection.Top];
	m := Copy (t, 0, Pos(':', t)-1);
	s := Copy (t, Pos(':', t)+1, 5);

	c := strToInt(m) * 60 + strToInt(s);

	F.StartTimer(c);
	FStart.Hide;

end;



// ------------------------------------------
// TheList.DoubleClick -> Start countdown

procedure TFStart.TheListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

	if (Key = VK_ESCAPE) then FStart.Hide
  	else if (Key = VK_DELETE) then TheList.DeleteRow(TheList.Selection.Top)
   else if (Key = VK_RETURN) then TheListDblClick(self)
   else if (Key = VK_F2) then p2EName.SetFocus;

end;



// ------------------------------------------
//

procedure TFStart.PagesChange(Sender: TObject);
begin
	if Pages.ActivePageIndex = 0 then begin

		Pages.Height := 80;
		Pages.Width := 180;

      FStart.Height := Pages.Height + 50;
      FStart.Width := Pages.Width + 24;

      Em.SetFocus;

   end
   else begin
		Pages.Height := 305;
		Pages.Width := 297;

      FStart.Height := Pages.Height + 50;
      FStart.Width := Pages.Width + 24;

      TheList.SetFocus;
   end;
end;


function TFStart.MoveValue(Value: Integer; PlusOrMinus: String; MinutesOrSeconds: String) : integer; // string sucks.
begin

	if (MinutesOrSeconds = 'Minutes')
   then // minutes............................


   	if (PlusOrMinus = 'Plus')
      then // plus...

         if Value < 999
      	then Result := Value + 1
         else Result := 999

      else // minus...

         if Value > 0
         then Result := Value - 1
         else Result := 0

   else // seconds............................


   	if (PlusOrMinus = 'Plus')
      then // plus...

      	if Value < 55
         then Result := ((Value div 5) + 1) * 5
         else Result := 0

      else // minus...

      	if Value > 5
         then Result := ((Value div 5) - 1) * 5
         else Result := 55;


end;



procedure TFStart.btnRemoveClick(Sender: TObject);
begin

   TheList.DeleteRow(TheList.Selection.Top);

   // hide fields if just editting
   TheListClick(self);


end;

procedure TFStart.p2btnStartClick(Sender: TObject);
begin
   TheListDblClick(self);
end;

procedure TFStart.btnEditClick(Sender: TObject);

	var t, m, s :string;
	c : integer;
begin

   p2EName.Visible := True;
   p2EM.Visible := True;
   p2ES.Visible := True;
   p2LColon.Visible := True;
   btnSave.Visible := True;

   p2EName.Text := TheList.Cells[0, TheList.Selection.Top];

   t := TheList.Cells[1, TheList.Selection.Top];
	m := Copy (t, 0, Pos(':', t)-1);
	s := Copy (t, Pos(':', t)+1, 5);

	c := strToInt(m) * 60 + strToInt(s);

   p2EM.Text := m;
   p2ES.Text := s;

   p2LColon.Visible := True;
   btnSave.Visible := True;
   btnSave.Caption := 'Save'; // modifiing mode


end;

procedure TFStart.TheListClick(Sender: TObject);
begin

   p2EName.Visible := False;
   p2EM.Visible := False;
   p2ES.Visible := False;
   p2LColon.Visible := False;
   btnSave.Visible := False;

end;

end.
